Package org.springframework.transaction.reactive

# Class TransactionSynchronizationManager

java.lang.Object
org.springframework.transaction.reactive.TransactionSynchronizationManager

public class TransactionSynchronizationManager extends Object
Central delegate that manages resources and transaction synchronizations per subscriber context. To be used by resource management code but not by typical application code.

Supports one resource per key without overwriting, that is, a resource needs to be removed before a new one can be set for the same key. Supports a list of transaction synchronizations if synchronization is active.

Resource management code should check for context-bound resources, for example, database connections, via `getResource`. Such code is normally not supposed to bind resources to units of work, as this is the responsibility of transaction managers. A further option is to lazily bind on first use if transaction synchronization is active, for performing transactions that span an arbitrary number of resources.

Transaction synchronization must be activated and deactivated by a transaction manager via `initSynchronization()` and `clearSynchronization()`. This is automatically supported by `AbstractReactiveTransactionManager`, and thus by all standard Spring transaction managers.

Resource management code should only register synchronizations when this manager is active, which can be checked via `isSynchronizationActive()`; it should perform immediate resource cleanup else. If transaction synchronization isn't active, there is either no current transaction, or the transaction manager doesn't support transaction synchronization.

Synchronization is for example used to always return the same resources within a transaction, for example, a database connection for any given connection factory.

Since:
  5.2
Author:
  Mark Paluch, Juergen Hoeller
See Also:
  - `isSynchronizationActive()`
  - `registerSynchronization(org.springframework.transaction.reactive.TransactionSynchronization)`
  - `TransactionSynchronization`

## Constructor Summary

Constructors
Constructor
Description
`TransactionSynchronizationManager(TransactionContext transactionContext)`

## Method Summary

Modifier and Type
Method
Description
`void`
`bindResource(Object key, Object value)`
Bind the given resource for the given key to the current context.
`void`
`clear()`
Clear the entire transaction synchronization state: registered synchronizations as well as the various transaction characteristics.
`void`
`clearSynchronization()`
Deactivate transaction synchronization for the current context.
`static reactor.core.publisher.Mono<TransactionSynchronizationManager>`
`forCurrentTransaction()`
Get the `TransactionSynchronizationManager` that is associated with the current transaction context.
`Integer`
`getCurrentTransactionIsolationLevel()`
Return the isolation level for the current transaction, if any.
`String`
`getCurrentTransactionName()`
Return the name of the current transaction, or `null` if none set.
`Object`
`getResource(Object key)`
Retrieve a resource for the given key that is bound to the current context.
`List<TransactionSynchronization>`
`getSynchronizations()`
Return an unmodifiable snapshot list of all registered synchronizations for the current context.
`boolean`
`hasResource(Object key)`
Check if there is a resource for the given key bound to the current context.
`void`
`initSynchronization()`
Activate transaction synchronization for the current context.
`boolean`
`isActualTransactionActive()`
Return whether there currently is an actual transaction active.
`boolean`
`isCurrentTransactionReadOnly()`
Return whether the current transaction is marked as read-only.
`boolean`
`isSynchronizationActive()`
Return if transaction synchronization is active for the current context.
`void`
`registerSynchronization(TransactionSynchronization synchronization)`
Register a new transaction synchronization for the current context.
`void`
`setActualTransactionActive(boolean active)`
Expose whether there currently is an actual transaction active.
`void`
`setCurrentTransactionIsolationLevel(Integer isolationLevel)`
Expose an isolation level for the current transaction.
`void`
`setCurrentTransactionName(String name)`
Expose the name of the current transaction, if any.
`void`
`setCurrentTransactionReadOnly(boolean readOnly)`
Expose a read-only flag for the current transaction.
`Object`
`unbindResource(Object key)`
Unbind a resource for the given key from the current context.
`Object`
`unbindResourceIfPossible(Object key)`
Unbind a resource for the given key from the current context.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### TransactionSynchronizationManager

public TransactionSynchronizationManager(TransactionContext transactionContext)

## Method Details

### forCurrentTransaction

public static reactor.core.publisher.Mono<TransactionSynchronizationManager> forCurrentTransaction()
Get the `TransactionSynchronizationManager` that is associated with the current transaction context.

Mainly intended for code that wants to bind resources or synchronizations.

Throws:
  `NoTransactionException` - if the transaction info cannot be found — for example, because the method was invoked outside a managed transaction

### hasResource

public boolean hasResource(Object key)
Check if there is a resource for the given key bound to the current context.

Parameters:
  `key` - the key to check (usually the resource factory)
Returns:
  if there is a value bound to the current context

### getResource

@Nullable public Object getResource(Object key)
Retrieve a resource for the given key that is bound to the current context.

Parameters:
  `key` - the key to check (usually the resource factory)
Returns:
  a value bound to the current context (usually the active resource object), or `null` if none

### bindResource

public void bindResource(Object key, Object value) throws IllegalStateException
Bind the given resource for the given key to the current context.

Parameters:
  `key` - the key to bind the value to (usually the resource factory)
  `value` - the value to bind (usually the active resource object)
Throws:
  `IllegalStateException` - if there is already a value bound to the context

### unbindResource

public Object unbindResource(Object key) throws IllegalStateException
Unbind a resource for the given key from the current context.

Parameters:
  `key` - the key to unbind (usually the resource factory)
Returns:
  the previously bound value (usually the active resource object)
Throws:
  `IllegalStateException` - if there is no value bound to the context

### unbindResourceIfPossible

@Nullable public Object unbindResourceIfPossible(Object key)
Unbind a resource for the given key from the current context.

Parameters:
  `key` - the key to unbind (usually the resource factory)
Returns:
  the previously bound value, or `null` if none bound

### isSynchronizationActive

public boolean isSynchronizationActive()
Return if transaction synchronization is active for the current context. Can be called before register to avoid unnecessary instance creation.

See Also:
  - `registerSynchronization(org.springframework.transaction.reactive.TransactionSynchronization)`

### initSynchronization

public void initSynchronization() throws IllegalStateException
Activate transaction synchronization for the current context. Called by a transaction manager on transaction begin.

Throws:
  `IllegalStateException` - if synchronization is already active

### registerSynchronization

public void registerSynchronization(TransactionSynchronization synchronization) throws IllegalStateException
Register a new transaction synchronization for the current context. Typically called by resource management code.

Note that synchronizations can implement the `Ordered` interface. They will be executed in an order according to their order value (if any).

Parameters:
  `synchronization` - the synchronization object to register
Throws:
  `IllegalStateException` - if transaction synchronization is not active
See Also:
  - `Ordered`

### getSynchronizations

public List<TransactionSynchronization> getSynchronizations() throws IllegalStateException
Return an unmodifiable snapshot list of all registered synchronizations for the current context.

Returns:
  unmodifiable List of TransactionSynchronization instances
Throws:
  `IllegalStateException` - if synchronization is not active
See Also:
  - `TransactionSynchronization`

### clearSynchronization

public void clearSynchronization() throws IllegalStateException
Deactivate transaction synchronization for the current context. Called by the transaction manager on transaction cleanup.

Throws:
  `IllegalStateException` - if synchronization is not active

### setCurrentTransactionName

public void setCurrentTransactionName(@Nullable String name)
Expose the name of the current transaction, if any. Called by the transaction manager on transaction begin and on cleanup.

Parameters:
  `name` - the name of the transaction, or `null` to reset it
See Also:
  - `TransactionDefinition.getName()`

### getCurrentTransactionName

@Nullable public String getCurrentTransactionName()
Return the name of the current transaction, or `null` if none set. To be called by resource management code for optimizations per use case, for example to optimize fetch strategies for specific named transactions.

See Also:
  - `TransactionDefinition.getName()`

### setCurrentTransactionReadOnly

public void setCurrentTransactionReadOnly(boolean readOnly)
Expose a read-only flag for the current transaction. Called by the transaction manager on transaction begin and on cleanup.

Parameters:
  `readOnly` - `true` to mark the current transaction as read-only; `false` to reset such a read-only marker
See Also:
  - `TransactionDefinition.isReadOnly()`

### isCurrentTransactionReadOnly

public boolean isCurrentTransactionReadOnly()
Return whether the current transaction is marked as read-only. To be called by resource management code when preparing a newly created resource.

Note that transaction synchronizations receive the read-only flag as argument for the `beforeCommit` callback, to be able to suppress change detection on commit. The present method is meant to be used for earlier read-only checks.

See Also:
  - `TransactionDefinition.isReadOnly()`
  - `TransactionSynchronization.beforeCommit(boolean)`

### setCurrentTransactionIsolationLevel

public void setCurrentTransactionIsolationLevel(@Nullable Integer isolationLevel)
Expose an isolation level for the current transaction. Called by the transaction manager on transaction begin and on cleanup.

Parameters:
  `isolationLevel` - the isolation level to expose, according to the R2DBC Connection constants (equivalent to the corresponding Spring TransactionDefinition constants), or `null` to reset it
See Also:
  - `TransactionDefinition.ISOLATION_READ_UNCOMMITTED`
  - `TransactionDefinition.ISOLATION_READ_COMMITTED`
  - `TransactionDefinition.ISOLATION_REPEATABLE_READ`
  - `TransactionDefinition.ISOLATION_SERIALIZABLE`
  - `TransactionDefinition.getIsolationLevel()`

### getCurrentTransactionIsolationLevel

@Nullable public Integer getCurrentTransactionIsolationLevel()
Return the isolation level for the current transaction, if any. To be called by resource management code when preparing a newly created resource (for example, a R2DBC Connection).

Returns:
  the currently exposed isolation level, according to the R2DBC Connection constants (equivalent to the corresponding Spring TransactionDefinition constants), or `null` if none
See Also:
  - `TransactionDefinition.ISOLATION_READ_UNCOMMITTED`
  - `TransactionDefinition.ISOLATION_READ_COMMITTED`
  - `TransactionDefinition.ISOLATION_REPEATABLE_READ`
  - `TransactionDefinition.ISOLATION_SERIALIZABLE`
  - `TransactionDefinition.getIsolationLevel()`

### setActualTransactionActive

public void setActualTransactionActive(boolean active)
Expose whether there currently is an actual transaction active. Called by the transaction manager on transaction begin and on cleanup.

Parameters:
  `active` - `true` to mark the current context as being associated with an actual transaction; `false` to reset that marker

### isActualTransactionActive

public boolean isActualTransactionActive()
Return whether there currently is an actual transaction active. This indicates whether the current context is associated with an actual transaction rather than just with active transaction synchronization.

To be called by resource management code that wants to differentiate between active transaction synchronization (with or without a backing resource transaction; also on PROPAGATION_SUPPORTS) and an actual transaction being active (with a backing resource transaction; on PROPAGATION_REQUIRED, PROPAGATION_REQUIRES_NEW, etc).

See Also:
  - `isSynchronizationActive()`

### clear

public void clear()
Clear the entire transaction synchronization state: registered synchronizations as well as the various transaction characteristics.

See Also:
  - `clearSynchronization()`
  - `setCurrentTransactionName(java.lang.String)`
  - `setCurrentTransactionReadOnly(boolean)`
  - `setCurrentTransactionIsolationLevel(java.lang.Integer)`
  - `setActualTransactionActive(boolean)`